﻿@using Portal.Models;
@using System.Web.UI.WebControls;
@using DevExpress.Web;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Toyota.Common.Web.Html.Helper;
@model Toyota.Common.Web.MVC.ModelHolder
@{     
    Layout = "~/Views/Layout/Dashboard.cshtml";
}


<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>



@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
        background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
        background-color: #DDECFF;
        border: 1px solid #94B6E8;
        color: #94B6E8;
        @*font-weight: bold;*@
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px; border:1px solid #6A8CCB;}

    

}


<style type="text/css">
    #ChildRoute, #ParentRoute, input#ChildRoute_I, input#ParentRoute_I, #LogisticPartnerOption, input#LogisticPartnerOption_I, #StatusOption, input#StatusOption_I, #VALID_FROM, input#VALID_FROM_I, #VALID_TO, input#VALID_TO_I
    {
        background-color: #F5F6ce;
    }
    
 
    input#EditChildRoute_I, #EditChildRoute,  
    input#EditParentRoute_I, #EditParentRoute,
    input#EditLP_I, #EditLP, 
    input#txtEditValidFrom_I, #txtEditValidFrom
    {
        background-color: #F6cece;
    }
    
    
    
</style>
<script type="text/javascript">
    var linkStatusObj = '';
    var linkNameObj = '';
    var _status = ''; //For saving data
    var statusButton = "S"; //For retrieve data when callback
    var GlobalSelectedKey = null; //For get selected row
    var isSelect = false; //For get selected row

    $(document).ready(function(){
        //grlLPHeader.SetText('');
        //GridgrlLPHeader.UnselectRows();
        //cmbActiveFlag.SetText('');

//        GridEditChildRoute.SetHeight(-145);
//        GridEditParentRoute.SetHeight(-145);
//        GridEditLP.SetHeight(-145);

            $('#GridEditLP').attr("style", "Height:100px");
    });


    


    function ConfirmBox(s, e, headerText,width) {
        
        if (e != '') {
            cfrmicon.src = '/Content/Images/' + e;
        } else {

            cfrmicon.src = '/Content/Images/help_24.png';
        }
        cfrmcaption.SetText(s);
        cfrmbox.SetWidth(width);
        cfrmbox.SetHeaderText(headerText);
        cfrmbox.Show();
    }


    function GetValidMonth(validMonth) {
         var paramStr = String(validMonth).replace('-', '');
         var paramStrLength = String(paramStr).length;

         var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
         var month = String(paramStr).substring(0, paramStrLength - 5);
         var monthEnum = {
             January: '01',
             February: '02',
             March: '03',
             April: '04',
             May: '05',
             June: '06',
             July: '07',
             August: '08',
             September: '09',
             October: '10',
             November: '11',
             December: '12'
         };
         var monthNum = "";
         if (Boolean(month))
             monthNum = monthEnum[month];
         return "01."+monthNum+"."+year;
     }

    function OnBeginCallbackGrid(s, e) {
        e.customArgs["ChildRoute"] = ChildRoute.GetValue();
        e.customArgs["ParentRoute"] = ParentRoute.GetText();
        e.customArgs["VALID_FROM"] = VALID_FROM.GetText();
        e.customArgs["VALID_TO"] = VALID_TO.GetText();
  
            //cmbActiveFlag
//        e.customArgs["LP_Cd"] = grlLPHeader.GetText();
//        e.customArgs["Active_Flag"] = cmbActiveFlag.GetSelectedItem().value;
        //e.customArgs["Button_Flag"] = statusButton;

        statusButton = "S";
    }

    function OnEndCallbackGrid(s, e) {
        if(GlobalSelectedKey != null && isSelect == true){
            isSelect = false;
            GridDeliveryRoutePrice.SelectRowsByKey(GlobalSelectedKey);
            GlobalSelectedKey = null;
            }

        if(statusButton == 'E'){
                btnSave.SetEnabled(false);
                btnCancel.SetEnabled(false);
                btnNew.SetEnabled(true);
                btnEdit.SetEnabled(true);
                btnDelete.SetEnabled(true);
//                btnSync.SetEnabled(true);
                btnSearch.SetEnabled(true);
                btnClear.SetEnabled(true);
                btnApprove.SetEnabled(true); 
        }
        else
        {
//            if (linkNameObj !='') {
//                if (linkStatusObj == '')
//                    document.getElementById(linkNameObj).style.display = "block";
//                else
//                    document.getElementById(linkNameObj).style.display = "none";
//                }
        }
    }

    function btnNew_click(s, e) {
        statusButton = "S"; 
        _status = "New";
        GlobalSelectedKey = GridDeliveryRoutePrice.GetSelectedKeysOnPage();
        btnSave.SetEnabled(true);
        btnCancel.SetEnabled(true);
        btnNew.SetEnabled(false);
        btnEdit.SetEnabled(false);
        btnDelete.SetEnabled(false);
        btnApprove.SetEnabled(false);
        //btnSync.SetEnabled(false);
        btnSearch.SetEnabled(false);
        btnClear.SetEnabled(false);
        btnApprove.SetEnabled(false);
        GridDeliveryRoutePrice.AddNewRow();
    }

    function btnEdit_click(s, e) {
        GlobalSelectedKey = GridDeliveryRoutePrice.GetSelectedKeysOnPage();
     
        if(GlobalSelectedKey.length == 0 || GlobalSelectedKey.length > 1) {
            //MessageBox('Please select one data to edit!','warning_icon.png','Warning');
            $.msgBox({
                    title: "Warning",
                    content: "Please select one data to edit!"
            });

            BehaviourNormal();
            return;
        }

        if(GlobalSelectedKey.length == 1) {
            
            GlobalSelectedKey = GridDeliveryRoutePrice.GetSelectedKeysOnPage();

            var j = JSON.stringify(GridDeliveryRoutePrice.GetSelectedKeysOnPage());
                j = j.substring(2,j.length - 2)
                j = j.split('|');
                //j = j[5];
            var valid_to = j[4];
            var approved = j[5];    


            if (valid_to!='9999-12-31' || approved !=''){
                $.msgBox({ title: "Warning", content: "Data cannot be edited!" });
            }else
            {
                _status = "Update";
                
                GridDeliveryRoutePrice.StartEditRowByKey(GlobalSelectedKey);
                console.log(GlobalSelectedKey);
                BehaviourAdd();
            }

        }
    }

    function btnSave_click(s, e) { 
        var Saving_Status = '';

        if (validating_insert()) 
        {
            //---=== Ajax store
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D61002/AddingDraftRoutePrice")",
                data: {
                        Saving_Status   : _status,
                        CHILD_ROUTE     : EditChildRoute.GetValue(),
                        PARENT_ROUTE    : EditParentRoute.GetValue(),
                        LP_CD           : EditLP.GetValue(),
                        VALID_FROM      : GetValidMonth(txtEditValidFrom.GetValue())
                    },
                    success: function (result) {
                        var resValue = result.split('|');
                        if (resValue[0] == 'Error')
                        {
                            //MessageBox(resValue[1],'not_ok_icon.png','Error');
                            $.msgBox({
                                    title: "Error",
                                    type: "error",
                                    content: resValue[1]
                            });
                        }
                        else
                        {
                            //MessageBox(resValue[1],'ok_icon.png','Information');
                            $.msgBox({
                                    title: "Success",
                                    type: "info",
                                    content: resValue[1]
                            });
                            BehaviourNormal();
                            isSelect = true;
                            GridDeliveryRoutePrice.CancelEdit();
                        }
                    },
                    error: function (result) {
                        var resValue = result.split('|');
                        //MessageBox(resValue[1],'not_ok_icon.png','Error');
                        $.msgBox({
                                    title: "Error",
                                    type: "error",
                                    content: resValue[1]
                            });
                        BehaviourNormal();
                    }
                });
                //---=== End ajax store
        } 
        else 
        {
             //MessageBox('Please fill all mandatory fields.','warning_icon.png','Warning');
             //BehaviourNormal();
             $.msgBox({
                       title: "Warning",
                       content: "Please fill all mandatory fields"
                      });
            
            
        }
    }

    function validating_insert() {
        var result = true;

        //var Active_Flag = cmbEditActiveFlag.GetText();

        if (EditChildRoute.GetValue() == null)
            result = false;

        if (EditParentRoute.GetValue() == null )
            result = false;

        if (EditLP.GetValue() == null )
            result = false;

        if (txtEditValidFrom.GetValue() == null)
            result = false;
        //if (Active_Flag.length == 0)
            //result = false;
        
        return result;
    }

    function btnCancel_click(s, e) {
        isSelect = true;
        GridDeliveryRoutePrice.CancelEdit();        
        BehaviourCancel();
    }
    
    function btnSearch_click(s, e) {


        if (ChildRoute.GetText() != '' || ParentRoute.GetText()!='' || VALID_FROM.GetText()!='' || VALID_TO.GetText()!='') {

            
            //if ( VALID_FROM.GetText()!=''){
            //    $.msgBox({ title: "Warning", type: "alert", content: "Please fill valid to!" });
                
            //}
            if (VALID_TO.GetText() != '') {
                if (VALID_FROM.GetValue() > VALID_TO.GetValue()) {
                    $.msgBox({ title: "Warning", type: "alert", content: "Valid from shouldn't be greater than valid to" });
                }
            }else{

                GridDeliveryRoutePrice.ClearFilter();
                GridDeliveryRoutePrice.UnselectRows();
                //GridDeliveryRoutePrice.PerformCallback();
                btnSave.SetEnabled(false);
                btnCancel.SetEnabled(false);
                btnNew.SetEnabled(false);
                btnEdit.SetEnabled(false);
                btnDelete.SetEnabled(false);
                //btnSync.SetEnabled(false);
                btnSearch.SetEnabled(false);
                btnClear.SetEnabled(false); 
                btnApprove.SetEnabled(false);
                statusButton = 'E';
                
            }
        }else {
            
            $.msgBox({ title: "Warning", content: "Please fill one or all search parameter!" });
        }

        

//        if (grlLPHeader.GetText() != '')
//        {
//            GridDeliveryRoutePrice.PerformCallback();
//            btnSave.SetEnabled(false);
//            btnCancel.SetEnabled(false);
//            btnNew.SetEnabled(false);
//            btnEdit.SetEnabled(false);
//            btnDelete.SetEnabled(false);
//            //btnSync.SetEnabled(false);
//            btnSearch.SetEnabled(false);
//            btnClear.SetEnabled(false); 
//            statusButton = 'E';
//        }
//        else
//        {
//            if(cmbActiveFlag.GetText() != '')
//            {
//                GridDeliveryRoutePrice.PerformCallback();
//                btnSave.SetEnabled(false);
//                btnCancel.SetEnabled(false);
//                btnNew.SetEnabled(false);
//                btnEdit.SetEnabled(false);
//                btnDelete.SetEnabled(false);
//                //btnSync.SetEnabled(false);
//                btnSearch.SetEnabled(false);
//                btnClear.SetEnabled(false);
//                statusButton = 'E';
//            }

//            else
//            {
//                //MessageBox('Please fill search parameter!','warning_icon.png','Warning');
//                $.msgBox({
//                       title: "Warning",
//                       content: "Please fill search parameter"
//                      });
//            }
//        }
    }

    function btnClear_click(s, e) {
        //grlLPHeader.SetText('');
        //GridgrlLPHeader.UnselectRows();
        //cmbActiveFlag.SetSelectedIndex(0);
        ChildRoute.SetText('');
        ParentRoute.SetText('');
        VALID_FROM.SetText('');
        VALID_TO.SetText('');


        GridChildRoute.UnselectRows();
        GridParentRoute.UnselectRows();


        GridDeliveryRoutePrice.ClearFilter();
    }

    
    function btnDelete_click(s, e) {
        CheckDeleteRoute(s,e);
    }

    function btnApprove_click (s,e) {
        
        var valGrid = JSON.stringify(GridDeliveryRoutePrice.GetSelectedKeysOnPage());
        valGrid = valGrid.replace('["','');
        valGrid = valGrid.replace('"]',';');
        valGrid = valGrid.replace(/","/g,';');

        GlobalSelectedKey = GridDeliveryRoutePrice.GetSelectedKeysOnPage();

        if(GlobalSelectedKey.length == 0) {
            //MessageBox('Please select data to delete!','warning_icon.png','Warning');
            $.msgBox({
                       title: "Warning",
                       content: "Please select data to approve"
                      });
            BehaviourNormal();
            return;
        }
        else
        {
            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D61002/ApproveDraftRoutePrice")",
                data: { 
                        GRID : valGrid
                },
                success: function (result) {
                    var resValue = result.split('|');
                    if (resValue[0] == 'Error')
                    {  
                        $.msgBox({ title: "Error", type: "error", content: resValue[1] });
                    }
                    else
                    {
                        $.msgBox({ title: "Success", type: "info", content: resValue[1] });
                        GridDeliveryRoutePrice.PerformCallback();
                        GridDeliveryRoutePrice.CancelEdit();
                        GridDeliveryRoutePrice.UnselectAllRowsOnPage();
                    }
                },
                error: function (result) {
                    var resValue = result.split('|');
                    $.msgBox({ title: "Error", type: "error", content: resValue[1] });
                }
            });
        }
    }

    function CheckDeleteRoute(s, e)
    {
        GlobalSelectedKey = GridDeliveryRoutePrice.GetSelectedKeysOnPage();

        console.log(GlobalSelectedKey);

        if(GlobalSelectedKey.length == 0) {
            //MessageBox('Please select data to delete!','warning_icon.png','Warning');
            $.msgBox({
                       title: "Warning",
                       content: "Please select data to delete"
                      });
            BehaviourNormal();
            return;
            }

        else
            {               
                $.msgBox({
                       type: "confirm",
                       content: "Are you sure want to delete data?",
                       buttons: [{ value: "Yes" }, { value: "No"}],
                       success: function (result) {
                            if (result == "Yes") { DeleteRoute(); }
                        }
                    });
                //ConfirmBox('Are you sure want to delete data?','help_24.png','Confirm Deletion');
            }
    }
        
    function DeleteRoute()
    {    
        GlobalSelectedKey = GridDeliveryRoutePrice.GetSelectedKeysOnPage();
        var SelectedKey = GlobalSelectedKey.toString();
        var Delete_Status;

        var valGrid = JSON.stringify(GridDeliveryRoutePrice.GetSelectedKeysOnPage());
        valGrid = valGrid.replace('["','');
        valGrid = valGrid.replace('"]',';');
        valGrid = valGrid.replace(/","/g,';');

            $.ajax({
                type: "POST",
                url: "@Url.Content("~/D61002/DeleteDraftRoutePrice")",
                data: { 
                        
                        GRID : valGrid
                        },
                            success: function (result) {
                            var resValue = result.split('|');
                            if (resValue[0] == 'Error')
                            {  
                                //MessageBox(resValue[1],'not_ok_icon.png','Error');
                                $.msgBox({
                                   title: "Error",
                                   type: "error",
                                   content: resValue[1]
                                  });
                            }
                            else
                            {
                                //MessageBox(resValue[1],'ok_icon.png','Information');
                                $.msgBox({
                                    title: "Success",
                                    type: "info",
                                    content: resValue[1]
                                });
                                GridDeliveryRoutePrice.PerformCallback();
                                GridDeliveryRoutePrice.CancelEdit();
                                GridDeliveryRoutePrice.UnselectAllRowsOnPage();
                                
                            }
                        },
                 error: function (result) {
                            var resValue = result.split('|');
                            //MessageBox(resValue[1],'not_ok_icon.png','Error');
                            $.msgBox({
                                   title: "Error",
                                   type: "error",
                                   content: resValue[1]
                                  });
                        }
            });
    }

    function BehaviourCancel(s, e) {
        btnSave.SetEnabled(false);
        btnCancel.SetEnabled(false);
        btnNew.SetEnabled(true);
        btnEdit.SetEnabled(true);
        btnDelete.SetEnabled(true);
        btnApprove.SetEnabled(true);
        //btnSync.SetEnabled(true);
        btnSearch.SetEnabled(true);
        btnClear.SetEnabled(true);
        btnApprove.SetEnabled(true);
    }

    function BehaviourNormal() {
        btnSave.SetEnabled(false);
        btnCancel.SetEnabled(false);
        btnNew.SetEnabled(true);
        btnEdit.SetEnabled(true);
        btnDelete.SetEnabled(true);
        btnApprove.SetEnabled(true);
        //btnSync.SetEnabled(true);
        btnSearch.SetEnabled(true);
        btnClear.SetEnabled(true);
        btnApprove.SetEnabled(true);
        if(isSelect == false){
            GridDeliveryRoutePrice.UnselectAllRowsOnPage();
        } else {
            isSelect = false;
            GridDeliveryRoutePrice.SelectRowsByKey(GlobalSelectedKey);
            GlobalSelectedKey = null;
        }
    }

    function BehaviourAdd() {
        btnSave.SetEnabled(true);
        btnCancel.SetEnabled(true);
        btnNew.SetEnabled(false);
        btnEdit.SetEnabled(false);
        btnDelete.SetEnabled(false);
        btnApprove.SetEnabled(false);
        //btnSync.SetEnabled(false);
        btnSearch.SetEnabled(false);
        btnClear.SetEnabled(false);
        btnApprove.SetEnabled(false);
        GridDeliveryRoutePrice.UnselectAllRowsOnPage();
    }

    function EditChildRouteBeginCallback(s, e) {

    }

    function EditChildRouteEndCallback(s, e) {
        if ((_status == 'New') || (_status == 'Update')) {
            if ((EditChildRoute.GetText() != '') || (EditChildRoute.GetText() != null)) {
                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/D61002/getLPCode")",
                    data: { RouteParent : EditChildRoute.GetText() },
                    success: function (result) {
                        EditLP.SetValue(result);
                     },
                     error: function (result) { }
                });
            }
        }
    }
</script>

@*<div style=" 
display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; margin-right: 10px; width: 1200px; ">*@


<div style="display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width: 1100px; margin-right: 10px;">

    @Html.Action("PartialHeader", "D61002")
</div>
<div style="height: 10px;">
</div>
@*<div style="
display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width: 1212px; margin-right: 10px;">*@

<div style="display: table; border: 1px solid #002D96; background-color: #DEECFD;
    padding: 10px; width: 1315px; margin-right: 10px;">
    <table cellpadding="2" cellspacing="2" border="0" style="float: right;">
        <tr>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnSave";
                    button.Text = "Save";
                    button.Width = Unit.Pixel(80);
                    button.ClientEnabled = false;
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnSave_click";
                }
                ).GetHtml()
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnCancel";
                    button.Text = "Cancel";
                    button.Width = Unit.Pixel(80);
                    button.ClientEnabled = false;
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnCancel_click";
                }
                ).GetHtml()
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnApprove";
                    button.Text = "Approve";
                    button.Width = Unit.Pixel(80);
                    button.ClientEnabled = true;
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnApprove_click";
                }
                ).GetHtml()
            </td>
            <td style="width: 800px;">
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnNew";
                    button.Text = "Add";
                    button.ClientEnabled = true;
                    button.Width = Unit.Pixel(80);
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnNew_click";
                }
                ).GetHtml()
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnEdit";
                    button.Text = "Edit";
                    button.Width = Unit.Pixel(80);
                    button.ClientEnabled = true;
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnEdit_click";
                }
                ).GetHtml()
            </td>
            <td>
                @Html.DevExpress().Button(
                button =>
                {
                    button.Name = "btnDelete";
                    button.Text = "Delete";
                    button.ClientEnabled = true;
                    button.Width = Unit.Pixel(80);
                    button.Style.Add("display", "inline-table");
                    button.ClientSideEvents.Click = "btnDelete_click";
                }
                ).GetHtml()
            </td>
        </tr>
    </table>
    @Html.Action("PartialListData", "D61002")
    @*<table cellpadding="2" cellspacing="2" style=" 
    min-width: 800px; width:100%">
        <tr>
            <td>
                
            </td>
        </tr>
    </table>*@
</div>


@Html.DevExpress().LoadingPanel(
    settings =>
    {
        settings.Name = "LoadingPanel";
        settings.Modal = true;
    }).GetHtml()
